#!/usr/bin/env python

import os
import sys
from rare import rare_marker
from viterbi import viterbi


def get_rare(word):
    """
    word - not used
    """
    return "_RARE_"


FN_ORG_TRAIN = 'gene.train'
FN_RARE_TRAIN = 'gene.2.train'
FN_COUNTS = 'gene.2.counts'
fn_dev = 'gene.dev'

def main():
    rm = rare_marker(get_rare, FN_ORG_TRAIN)
    with open(FN_RARE_TRAIN, 'w') as f_out:
        rm.get_rare_train(f_out)
    
    os.system('python count_freqs.py ' + FN_RARE_TRAIN + ' > ' + FN_COUNTS)
    
    vi = viterbi(get_rare, FN_COUNTS)
    vi.get_tag_from_file(fn_dev)

if __name__ == "__main__":
    # Usage:
    #     python p2.py [dev_file]
    #     default dev_file = 'gene.dev'
    if len(sys.argv) >= 2:
        fn_dev = sys.argv[1]
    main()
