#!/usr/bin/python

import os
import sys
import string
from rare import rare_marker
from viterbi import viterbi


NUMERIC_TAG = "_NUMERIC_"
ALLCAP_TAG = "_ALLCAP_"
LASTCAP_TAG = "_LASTCAP_"
RARE_TAG = "_RARE_"


def get_rare(word):
    for c in word:
        if c in string.digits:
            return NUMERIC_TAG
    
    all_capital = True
    for c in word:
        if c not in string.ascii_uppercase:
            all_capital = False
            break;
    if all_capital:
        return ALLCAP_TAG
    
    if word[-1] in string.ascii_uppercase:
        return LASTCAP_TAG
    return RARE_TAG


FN_ORG_TRAIN = 'gene.train'
FN_RARE_TRAIN = 'gene.3.train'
FN_COUNTS = 'gene.3.counts'
fn_dev = 'gene.dev'

def main():
    rm = rare_marker(get_rare, FN_ORG_TRAIN)
    with open(FN_RARE_TRAIN, 'w') as f_out:
        rm.get_rare_train(f_out)
    
    os.system('python count_freqs.py ' + FN_RARE_TRAIN + ' > ' + FN_COUNTS)
    
    vi = viterbi(get_rare, FN_COUNTS)
    vi.get_tag_from_file(fn_dev)

if __name__ == "__main__":
    # Usage:
    #     python p3.py [dev_file]
    #     default dev_file = 'gene.dev'
    if len(sys.argv) >= 2:
        fn_dev = sys.argv[1]
    main()
